﻿using Microsoft.Extensions.Logging;

namespace ConsoleApp2.Services.ErrorRecorder;

public sealed class InputErrorRecorder : ErrorRecorder
{
    private readonly string _outputDir =
        Path.Combine(AppDomain.CurrentDomain.BaseDirectory, $"ErrorRecords/{UID}/Input");
    
    public InputErrorRecorder(ILogger logger) : base(logger)
    {
    }
    
    public Task LogErrorRecordAsync(DataRecord record, Exception exception) =>
        LogErrorRecordAsync(_outputDir, record, exception);

    public Task LogErrorRecordAsync(IEnumerable<DataRecord> records, Exception exception) =>
        LogErrorRecordAsync(_outputDir, records, exception);
}